// R_COM.CPP : RS232-Klasse
// G. TAMM, DF9ZO 1999-2007
//-------------------------
#ifndef _R_COM_H_
  #include "R_COM.H"
#endif
//+Globale Variablen+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
COM comport;
//-----------------------------------------------------------------------------
const char COMX_s[20][7]        ={"COM 1","COM 2","COM 3","COM 4","COM 5",
                                  "COM 6","COM 7","COM 8","COM 9","COM 10",
                                  "COM 11","COM 12","COM 13","COM 14","COM 15",
                                  "COM 16","COM 17","COM 18","COM 19","COM 20"};
const char BAUD_s[12][7]        ={"75","150","300","600",
                                  "1200","2400","4800","9600",
                                  "19200","38400","57600","115200"};
const int  BAUD_n[12]           ={75,150,300,600,
                                  1200,2400,4800,9600,
                                  19200,38400,57600,115200};
const char DATA_s[5][2]         ={"4","5","6","7","8"};
const int  DATA_n[5]            ={4,5,6,7,8};
const char STOP_s[3][4]         ={"1","1.5","2"};
const char PARI_s[5][6]         ={"ODD","EVEN","MARK","SPACE","NO"};
const char PROT_s[4][9]         ={"RTS/CTS","DTR/DSR","Xon/Xoff","NO"};

int        COMAvail[20]         ={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
//+Funktionen++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void COMTest_Single(int comport)
{
 char   portstr[7];
 HANDLE hCom;

 COMAvail[comport]=0;
 wsprintf(portstr,"COM%d",comport+1);
 hCom=INVALID_HANDLE_VALUE;
 hCom=CreateFile(portstr,GENERIC_READ | GENERIC_WRITE,
                 0,NULL,OPEN_EXISTING,0,NULL);
 if (hCom != INVALID_HANDLE_VALUE)
  {
   COMAvail[comport]=1;CloseHandle(hCom);
  }
}

void COMTest_Complete(int shmsg)
{
 int    x;
 char   portstr[7],str[1000],yes[]="Available",no[]="NOT available",
        nl[]="\n",dop[]=": ";
 HANDLE hCom;

 for (x=0;x < 20;x++)
  {
   COMAvail[x]=0;
   wsprintf(portstr,"COM%d",x+1);
   hCom=INVALID_HANDLE_VALUE;
   hCom=CreateFile(portstr,GENERIC_READ | GENERIC_WRITE,
                   0,NULL,OPEN_EXISTING,0,NULL);
   if (hCom != INVALID_HANDLE_VALUE)
    {
     COMAvail[x]=1;CloseHandle(hCom);
    }
  }
 //---------------------------------------------------------
 strcpy(str,COMX_s[0]);strcat(str,"\t");strcat(str,dop);
 if (COMAvail[0]) strcat(str,yes);else strcat(str,no);
 for (x=1;x < 20;x++)
  {
   strcat(str,nl);strcat(str,COMX_s[x]);strcat(str,"\t");strcat(str,dop);
   if (COMAvail[x]) strcat(str,yes);else strcat(str,no);
  }
 if (shmsg) MyMsgBox("COM-Ports",str,2);
}
//COMSETTINGSDlgDlg++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IMPLEMENT_DYNAMIC(COMSETTINGSDlg, CDialog)
COMSETTINGSDlg::COMSETTINGSDlg(CWnd* pParent /*=NULL*/)
	           : CDialog(COMSETTINGSDlg::IDD, pParent)
               , m_pollmode(FALSE)
               , m_polliv(_T("10"))
{
}

COMSETTINGSDlg::~COMSETTINGSDlg()
{
}

void COMSETTINGSDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Radio(pDX, IDC_COM_POLL_R0, m_pollmode);
    DDX_Text(pDX, IDC_COM_POLL_ED, m_polliv);
	DDV_MaxChars(pDX, m_polliv, 4);
}


BEGIN_MESSAGE_MAP(COMSETTINGSDlg, CDialog)
    ON_BN_CLICKED(IDOK, OnOK)
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL COMSETTINGSDlg::OnInitDialog() 
{
 CComboBox* pCB;
 int        x;

 CDialog::OnInitDialog();
 SetIcon(::LoadIcon(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME)),TRUE);

 pCB=(CComboBox*) GetDlgItem(IDC_COM_COM_CB);
 for (x=0;x<20;x++) {pCB->AddString(COMX_s[x]);}
 pCB->SetCurSel(COM_PORT);
 
 pCB=(CComboBox*) GetDlgItem(IDC_COM_BAUD_CB);
 for (x=0;x<12;x++) {pCB->AddString(BAUD_s[x]);}
 pCB->SetCurSel(COM_BAUD);

 pCB=(CComboBox*) GetDlgItem(IDC_COM_DATA_CB);
 for (x=0;x<5;x++)  {pCB->AddString(DATA_s[x]);}
 pCB->SetCurSel(COM_DATA);

 pCB=(CComboBox*) GetDlgItem(IDC_COM_STOP_CB);
 for (x=0;x<3;x++)  {pCB->AddString(STOP_s[x]);}
 pCB->SetCurSel(COM_STOP);

 pCB=(CComboBox*) GetDlgItem(IDC_COM_PARI_CB);
 for (x=0;x<5;x++)  {pCB->AddString(PARI_s[x]);}
 pCB->SetCurSel(COM_PARI);

 pCB=(CComboBox*) GetDlgItem(IDC_COM_PROT_CB);
 for (x=0;x<4;x++)  {pCB->AddString(PROT_s[x]);}
 pCB->SetCurSel(COM_PROT);

 GetDlgItem(IDOK)->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control
}
//-----------------------------------------------------------------------------
void COMSETTINGSDlg::OnOK()
{
 CComboBox* pCB;

 if (!UpdateData(TRUE)) return;

 pCB=(CComboBox*) GetDlgItem(IDC_COM_COM_CB);
 COM_PORT=pCB->GetCurSel();
 pCB=(CComboBox*) GetDlgItem(IDC_COM_BAUD_CB);
 COM_BAUD=pCB->GetCurSel();
 pCB=(CComboBox*) GetDlgItem(IDC_COM_DATA_CB);
 COM_DATA=pCB->GetCurSel();
 pCB=(CComboBox*) GetDlgItem(IDC_COM_STOP_CB);
 COM_STOP=pCB->GetCurSel();
 pCB=(CComboBox*) GetDlgItem(IDC_COM_PARI_CB);
 COM_PARI=pCB->GetCurSel();
 pCB=(CComboBox*) GetDlgItem(IDC_COM_PROT_CB);
 COM_PROT=pCB->GetCurSel();
	
 CDialog::OnOK();
}
//COM-Klasse+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
COM::COM()
{
 ComCOMX=ComBAUD=ComDATA=ComSTOP=ComPARI=ComPROT=-1;
 hCom=INVALID_HANDLE_VALUE;
 RXbuf=10000;TXbuf=10000;
 PortIsActive=0;
 oldMSR[0]=oldMSR[1]=oldMSR[2]=oldMSR[3]=-99;
 actMSR[0]=actMSR[1]=actMSR[2]=actMSR[3]=0;
 ErrTxt[0]='\0';PortName[0]='\0';
 strcpy(errtxt1,"OPEN");strcpy(errtxt2,"CLOSE");strcpy(errtxt3,"WRITE");
}
//-----------------------------------------------------------------------------
COM::~COM()
{
 if (hCom != INVALID_HANDLE_VALUE)
  {
   ClrRXBuf();ClrTXBuf();
   Close();
  }
}
//-----------------------------------------------------------------------------
void COM::ShComError(void)
{
 /*
 LPTSTR lpMsgBuf;

 ErrorNum=GetLastError();
 //-----------------
 FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
    				NULL,GetLastError(),
    				MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),// Default language
    				(LPTSTR) &lpMsgBuf,0,NULL);
 MessageBox(NULL,lpMsgBuf,"COM-ERROR",MB_OK | MB_ICONSTOP | MB_TASKMODAL);
 //-----------------
 LocalFree(lpMsgBuf);*/
 ::MessageBox(NULL,ErrTxt,"COM-ERROR",MB_OK | MB_ICONSTOP | MB_TASKMODAL);
}
//-----------------------------------------------------------------------------
int COM::Open(int comx,int baud,int data,int stop,int pari,int prot,
					   int rxbuf,int txbuf)
{
 int res;

 ComCOMX=comx;ComBAUD=baud;ComDATA=data;ComSTOP=stop;
 ComPARI=pari;ComPROT=prot;RXbuf=rxbuf;TXbuf=txbuf;
 wsprintf(PortName,"COM%d",ComCOMX+1);
 hCom=INVALID_HANDLE_VALUE;
 //--------------------------------------------------
 hCom=CreateFile(PortName,
 				 GENERIC_READ | GENERIC_WRITE,
                 0,//comm devices must be opened w/exclusive-access
    			 NULL,//no security attrs
                 OPEN_EXISTING,//comm devices must use OPEN_EXISTING
                 0,//not overlapped I/O
    			 NULL);//hTemplate must be NULL for comm devices
 if (hCom == INVALID_HANDLE_VALUE)
  {
   strcpy(ErrTxt,errtxt1);strcat(ErrTxt,"(1)");
   ShComError();return 0;
  }
 //-Alte DCB speichern-------------------------------
 res=GetCommState(hCom,&olddcb);
 if (res == 0)
  {
   strcpy(ErrTxt,errtxt1);strcat(ErrTxt,"(2)");
   ShComError();hCom=INVALID_HANDLE_VALUE;return 0;
  }
 //-Neue DCB setzen----------------------------------
 dcb.BaudRate=BAUD_n[ComBAUD];
 dcb.ByteSize=DATA_n[ComDATA];
 switch (ComPARI)
  {
   case 0:dcb.Parity=ODDPARITY;break;
   case 1:dcb.Parity=EVENPARITY;break;
   case 2:dcb.Parity=MARKPARITY;break;
   case 3:dcb.Parity=SPACEPARITY;break;
   case 4:dcb.Parity=NOPARITY;break;
   default:dcb.Parity=NOPARITY;break;
  }
 switch (ComSTOP)
  {
   case 0:dcb.StopBits=ONESTOPBIT;break;
   case 1:dcb.StopBits=ONE5STOPBITS;break;
   case 2:dcb.StopBits=TWOSTOPBITS;break;
   default:dcb.StopBits=ONESTOPBIT;break;
  }
// fOutxCtsFlow , fRtsControl / fOutxDsrFlow , fDtrControl / fOutX , fInX
  switch (ComPROT)
  {
   case 0:// RTS/CTS
          dcb.fRtsControl=RTS_CONTROL_HANDSHAKE;dcb.fOutxCtsFlow=TRUE;
          dcb.fDtrControl=DTR_CONTROL_DISABLE;dcb.fOutxDsrFlow=FALSE;
  		  dcb.fInX=dcb.fOutX=FALSE;
	  	  break;
   case 1:// DTR/DSR
          dcb.fRtsControl=RTS_CONTROL_DISABLE;dcb.fOutxCtsFlow=FALSE;
          dcb.fDtrControl=DTR_CONTROL_HANDSHAKE;dcb.fOutxDsrFlow=TRUE;
  		  dcb.fInX=dcb.fOutX=FALSE;
	  	  break;
   case 2:// Xon/Xoff
          dcb.fRtsControl=RTS_CONTROL_DISABLE;dcb.fOutxCtsFlow=FALSE;
		  dcb.fDtrControl=DTR_CONTROL_DISABLE;dcb.fOutxDsrFlow=FALSE;
          dcb.fInX=dcb.fOutX=TRUE;
          break;
   case 3:// NO
   		 dcb.fOutxCtsFlow=dcb.fRtsControl=0;
         dcb.fOutxDsrFlow=dcb.fDtrControl=0;
         dcb.fOutX=dcb.fInX=0;
	  	 break;
  }
 dcb.fNull=0;//Kein null stripping
 res=SetCommState(hCom,&dcb);
 if (res == 0)
  {
   strcpy(ErrTxt,errtxt1);strcat(ErrTxt,"(3)");
   ShComError();hCom=INVALID_HANDLE_VALUE;return 0;
  }
 //--------------------------------------------------
 res=SetupComm(hCom,RXbuf,TXbuf);
 if (res == 0)
  {
   strcpy(ErrTxt,errtxt1);strcat(ErrTxt,"(4)");
   ShComError();hCom=INVALID_HANDLE_VALUE;return 0;
  }
 //--------------------------------------------------
 ClrTXBuf();ClrRXBuf();
 PortIsActive=1;
 return 1;
}
//-----------------------------------------------------------------------------
int COM::Close(void)
{
 int res;

 if (hCom == INVALID_HANDLE_VALUE) return 0;
 FlushFileBuffers(hCom);//TXBuf senden
 ClrRXBuf();ClrTXBuf();
 //-Alte DCB setzen-------------------------
 res=SetCommState(hCom,&olddcb);
 if (res == 0)
  {
   strcpy(ErrTxt,errtxt2);strcat(ErrTxt,"(1)");
   ShComError();return 0;
  } 
 //-Port schliessen-------------------------
 res=CloseHandle(hCom);
 if (res == 0)
  {
   strcpy(ErrTxt,errtxt2);strcat(ErrTxt,"(2)");
   ShComError();hCom=INVALID_HANDLE_VALUE;
   return 0;
  }else
  {
   hCom=INVALID_HANDLE_VALUE;
   PortIsActive=0;
   return 1;
  }
}
//-----------------------------------------------------------------------------
int COM::ClrRXBuf(void)
{
 int res;

 res=PurgeComm(hCom,PURGE_RXABORT);PurgeComm(hCom,PURGE_RXCLEAR);
 if (res == 0)
  {
   strcpy(ErrTxt,"ClrRXBuf");ShComError();return 0;
  }
 return 1;
}

int COM::ClrTXBuf(void)
{
 int res;

 res=PurgeComm(hCom,PURGE_TXABORT);PurgeComm(hCom,PURGE_TXCLEAR);
 if (res == 0)
  {
   strcpy(ErrTxt,"ClrTXBuf");ShComError();return 0;
  }
 return 1;
}
//-----------------------------------------------------------------------------
void COM::SetDTR()
{
 int res;

 res=EscapeCommFunction(hCom,SETDTR);
 if (res == 0) {strcpy(ErrTxt,"SETDTR");ShComError();}
}

void COM::ResDTR()
{
 int res;

 res=EscapeCommFunction(hCom,CLRDTR);
 if (res == 0) {strcpy(ErrTxt,"CLRDTR");ShComError();}
}

void COM::SetRTS()
{
 int res;

 res=EscapeCommFunction(hCom,SETRTS);
 if (res == 0) {strcpy(ErrTxt,"SETRTS");ShComError();}
}

void COM::ResRTS()
{
 int res;

 res=EscapeCommFunction(hCom,CLRRTS);
 if (res == 0) {strcpy(ErrTxt,"CLRRTS");ShComError();}
}
//-----------------------------------------------------------------------------
int COM::ReadMSR(void)
{
 int res;
 unsigned long MSR;

 res=GetCommModemStatus(hCom,&MSR);
 if (res == 0) {strcpy(ErrTxt,"ReadMSR");ShComError();return 0;}
 //-------------------------------------------------------------
 if (MSR & MS_RLSD_ON) RLSD=1;else RLSD=0;actMSR[0]=RLSD;
 if (MSR & MS_RING_ON) RING=1;else RING=0;actMSR[1]=RING;
 if (MSR & MS_CTS_ON)  CTS=1;else CTS=0;actMSR[2]=CTS;
 if (MSR & MS_DSR_ON)  DSR=1;else DSR=0;actMSR[3]=DSR;
 //-------------------------------------------------------------
 if (actMSR[0]!=oldMSR[0] || actMSR[1]!=oldMSR[1] ||
 	  actMSR[2]!=oldMSR[2] || actMSR[3]!=oldMSR[3])
  {
   oldMSR[0]=actMSR[0];oldMSR[1]=actMSR[1];oldMSR[2]=actMSR[2];oldMSR[3]=actMSR[3];
   return 1;
  }else return 0;
}
//-----------------------------------------------------------------------------
int COM::RXBufFree(void)
{
 COMSTAT comstat;
 DWORD err;

 ClearCommError(hCom,&err,&comstat);
 return RXbuf-comstat.cbInQue;
}

int COM::RXBufUsed(void)
{
 COMSTAT comstat;
 DWORD err;

 ClearCommError(hCom,&err,&comstat);
 return comstat.cbInQue;
}

int COM::TXBufFree(void)
{
 COMSTAT comstat;
 DWORD err;

 ClearCommError(hCom,&err,&comstat);
 return TXbuf-comstat.cbOutQue;
}

int COM::TXBufUsed(void)
{
 COMSTAT comstat;
 DWORD err;

 ClearCommError(hCom,&err,&comstat);
 return comstat.cbOutQue;
}
//-----------------------------------------------------------------------------
int COM::ReadChar(void)
{
 COMSTAT comstat;
 DWORD err,read;
 unsigned char ch;// !!!

 ClearCommError(hCom,&err,&comstat);
 if (comstat.cbInQue == 0) return -1;
 //----------------------------------
 ReadFile(hCom,&ch,1,&read,NULL);
 if (read == 1) return ch;else
  {
   strcpy(ErrTxt,"Read");ShComError();
   return -2;
  }
}
//-----------------------------------------------------------------------------
int COM::WriteChar(int ch)
{
 COMSTAT comstat;
 DWORD err,written;

 ClearCommError(hCom,&err,&comstat);
 if (TXbuf-comstat.cbOutQue < 2)
  {
   strcpy(ErrTxt,errtxt3);strcat(ErrTxt,"(1)");
   ShComError();return -1;
  }
 //----------------------------------
 WriteFile(hCom,&ch,1,&written,NULL);
 if (written==1) return 1;else
  {
   strcpy(ErrTxt,errtxt3);strcat(ErrTxt,"(2)");
   ShComError();return -2;
  }
}

int COM::WriteStr(char *src,int mode)
{
 COMSTAT comstat;
 DWORD x,err,written,le;

 le=strlen(src);
 if (mode == 1) {src[le]=13;src[le+1]=0;le+=1;}
 if (mode == 2) {src[le]=13;src[le+1]=10;src[le+2]=0;le+=2;}
 ClearCommError(hCom,&err,&comstat);
 if (TXbuf-comstat.cbOutQue < le+1)
  {
   strcpy(ErrTxt,errtxt3);strcat(ErrTxt,"(3)");
   ShComError();return -1;
  }
 //----------------------------------
 for (x=0;x<le;x++)
  {
   WriteFile(hCom,&/*(unsigned char)*/src[x],1,&written,NULL);
   if (written != 1)
    {
     strcpy(ErrTxt,errtxt3);strcat(ErrTxt,"(4)");
     ShComError();return -2;
    }
  }
 return le;
} 
//+Radiofunktionen+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int COM::TestCmd(int subcmd)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;
   TXstr[5]=0x05;TXstr[6]=0x00;TXstr[7]=0x26;
   TXstr[8]=subcmd;
   TXstr[9]=IB_EoM;le=10;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
 return 1;
}

int COM::AskFREQ()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x03;
   TXstr[5]=IB_EoM;le=6;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
 return 1;
}

void COM::SetFREQ(char *freqstr)
{  
 char fstr[13];
 int  dest[5];
 int  x,le=0;
 
 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   strcpy(fstr,freqstr);
   IB_FreqToSend(dest,fstr);
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x05;
   //if (IRADIO_IB[Radio_Num].IB_Transc) TXstr[4]=0;else TXstr[4]=5;
   for (x=5;x < IRadio_IB_Da_n+5;x++) TXstr[x]=dest[x-5];
   TXstr[x]=IB_EoM;le=6+IRadio_IB_Da_n;         
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::RXBufferToFstr(int arrmaxind)
{
 int  x;
 char str[10];

 if (IRadio_IB_Da_n == 4)
  {
   Fact_s[0]='0';Fact_s[1]='0';
  }else
  {
   IB_HexToDecStr(str,RXb[arrmaxind  ]);Fact_s[0]=str[0];Fact_s[1]=str[1];
  }
 IB_HexToDecStr  (str,RXb[arrmaxind-1]);Fact_s[2]=str[0];Fact_s[3]=str[1];
 IB_HexToDecStr  (str,RXb[arrmaxind-2]);Fact_s[4]=str[0];Fact_s[5]=str[1];
 IB_HexToDecStr  (str,RXb[arrmaxind-3]);Fact_s[6]=str[0];Fact_s[7]=str[1];
 IB_HexToDecStr  (str,RXb[arrmaxind-4]);Fact_s[8]=str[0];Fact_s[9]=str[1];
 Fact_s[10]=0;
 StrInsChPos(Fact_s,'.',4);StrInsChPos(Fact_s,',',8);
 x=0;while (Fact_s[x] == '0') {Fact_s[x]=' ';x++;}
 Fact_n=FstrToFnum(Fact_s);
}
//-----------------------------------------------------------------------------
int COM::AskMODE()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x04;
   TXstr[5]=IB_EoM;le=6;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
 return 1;
}

void COM::SetMODE(int moind,int fiind)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   //if (IRADIO_IB[Radio_Num].IB_Transc) TXstr[4]=1;else TXstr[4]=6;
   TXstr[4]=0x06;
   switch (moind)
    {
     case 0:TXstr[5]=0x1;le=1;break;// USB
     case 1:TXstr[5]=0x0;le=1;break;// LSB
     case 2:TXstr[5]=0x5;le=1;break;// FM
     case 3:TXstr[5]=0x6;le=1;break;// FMW
     case 4:TXstr[5]=0x2;le=1;break;// AM
     case 5:TXstr[5]=0x3;le=1;break;// CW
     case 6:TXstr[5]=0x4;le=1;break;// RTTY
     case 7:TXstr[5]=0x7;le=1;break;// CW-R
     case 8:TXstr[5]=0x8;le=1;break;// RTTY-R
     // TXstr[5]=0x5;TXstr[6]=0x2;le=2;break;// FMN
    }
   if (IRadio_IB_DSP_Fi == 0)//HW-Filter
    {
     if (moind == 0 || moind == 1) x=0;else x=3*(moind-1);
     if (IRadio_IB_Fi_n[x+fiind] > -1) {TXstr[6]=IRadio_IB_Fi_n[x+fiind];le=2;}
     TXstr[5+le]=IB_EoM;le=6+le;
    }else                    //DSP-Filter 
    {
     if (fiind == 0) TXstr[6]=2;
     if (fiind == 1) TXstr[6]=3;
     if (fiind == 2) TXstr[6]=1;
     TXstr[7]=IB_EoM;le=7;
    }
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::RXBufferToMoFi(int mo_ind,int fi_ind)
{
 int x;

 Mact_n=0;
 if (RXb[mo_ind] == 0x0) Mact_n=1;//LSB
 if (RXb[mo_ind] == 0x1) Mact_n=0;//USB
 if (RXb[mo_ind] == 0x2) Mact_n=4;//AM
 if (RXb[mo_ind] == 0x3) Mact_n=5;//CW
 if (RXb[mo_ind] == 0x4) Mact_n=6;//RTTY
 if (RXb[mo_ind] == 0x5) Mact_n=2;//FM
 if (RXb[mo_ind] == 0x6) Mact_n=3;//FMW
 if (RXb[mo_ind] == 0x7) Mact_n=7;//CW-R
 if (RXb[mo_ind] == 0x8) Mact_n=8;//RTTY-R
 
 FIact_n=0;
 if (IRadio_IB_DSP_Fi == 0)  //HW-Filter
  {
   if (Mact_n < 6)
    {
     if (Mact_n == 0 || Mact_n == 1) x=0;else x=3*(Mact_n-1);
     if (IRadio_IB_Fi_n[x  ] > -1 && RXb[fi_ind] == IRadio_IB_Fi_n[x  ]) FIact_n=0;
     if (IRadio_IB_Fi_n[x+1] > -1 && RXb[fi_ind] == IRadio_IB_Fi_n[x+1]) FIact_n=1;
     if (IRadio_IB_Fi_n[x+2] > -1 && RXb[fi_ind] == IRadio_IB_Fi_n[x+2]) FIact_n=2;
    }
  }else                      //DSP-Filter 
  {
   if (RXb[fi_ind] == 1) FIact_n=2;//wide
   if (RXb[fi_ind] == 2) FIact_n=0;//normal
   if (RXb[fi_ind] == 3) FIact_n=1;//narrow   
  }

 strcpy(Mact_s,MOs[Mact_n]);
 strcpy(FIact_s,FIs[FIact_n]);
}
//-----------------------------------------------------------------------------
void COM::SwitchANT(int ant)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x12;TXstr[5]=ant;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SwitchATT(int att)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x11;
   if (IRadio_IB_Adr_n == 112)//IC-7000
    {
     switch (att)
      {
	   case  0:TXstr[5]=0x00;break;
	   case  1:TXstr[5]=0x12;break;
      }
    }else
    {
     switch (att)
      {
	   case  0:TXstr[5]=0x00;break;
	   case  1:TXstr[5]=0x10;break;
       case  2:TXstr[5]=0x20;break;
       case  3:TXstr[5]=0x30;break;
      }
    }
   TXstr[6]=IB_EoM;le=7;          
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SwitchPAMP(int pamp)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x16;TXstr[5]=0x2;TXstr[6]=pamp;
   TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SwitchAGC(int agc)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x16;TXstr[5]=0x12;TXstr[6]=agc;
   TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SwitchDUP(int dup)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x0F;
   if (dup == 0) TXstr[5]=0x10;
   if (dup == 1) TXstr[5]=0x11;
   if (dup == 2) TXstr[5]=0x12;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SwitchVFO(int vfo)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x07;
   if (vfo == 0) TXstr[5]=0x00;else TXstr[5]=0x01;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SwitchVFOsEQUAL() 
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x07;TXstr[5]=0xA0;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SwitchVM(int vm)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   if (vm == 0) TXstr[4]=0x07;else TXstr[4]=0x08;//MEM
   TXstr[5]=IB_EoM;le=6;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SwitchANF(int anf)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x16;TXstr[5]=0x41;TXstr[6]=anf;
   TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}
//-----------------------------------------------------------------------------
void COM::SwitchNR(int nr)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x16;TXstr[5]=0x40;TXstr[6]=nr;
   TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::AskNR_lev()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;

   TXstr[4]=0x14;TXstr[5]=0x06;
   TXstr[6]=IB_EoM;le=7;   

   //TXstr[4]=0x1A;TXstr[5]=0x05;TXstr[6]=0x01;TXstr[7]=0x14;
   //TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetNR_lev(int nrlev_n)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x06;
   IB_DecToBCD(TXstr[6],TXstr[7],nrlev_n);
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}
//-----------------------------------------------------------------------------
void COM::SwitchNB(int nb)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x16;TXstr[5]=0x22;TXstr[6]=nb;
   TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::AskNB_lev()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x12;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetNB_lev(int nblev_n)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x12;
   IB_DecToBCD(TXstr[6],TXstr[7],nblev_n);
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios  
}

void COM::AskNB_wid()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0x05;TXstr[6]=0x01;TXstr[7]=0x13;
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetNB_wid(int nbwid_n)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0x05;TXstr[6]=0x01;TXstr[7]=0x13;   
   IB_DecToBCD(TXstr[8],TXstr[9],nbwid_n);
   TXstr[10]=IB_EoM;le=11;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios  
}
//-----------------------------------------------------------------------------
void COM::AskSQL_SW_oc()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x15;TXstr[5]=0x1;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios
}

int COM::AskSQL_HW_oc()
{
 if (ReadMSR()) SQL_oc=RING;
 return SQL_oc;
}

void COM::AskSQL_lev()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x3;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios
}

void COM::SetSQL_lev(int sqllev_n)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x03;
   IB_DecToBCD(TXstr[6],TXstr[7],sqllev_n);
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}
//-----------------------------------------------------------------------------
void COM::AskAF_lev()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x01;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetAF_lev(int af_n)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x01;
   IB_DecToBCD(TXstr[6],TXstr[7],af_n);
   TXstr[8]=IB_EoM;le=9;
   //TXstr[6]=af;
   //TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}
//-----------------------------------------------------------------------------
void COM::AskRF_lev()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x02;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetRF_lev(int rf_n)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x02;
   IB_DecToBCD(TXstr[6],TXstr[7],rf_n);
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}
//-----------------------------------------------------------------------------
void COM::AskSM_lev()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x15;TXstr[5]=0x2;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios
}
//-----------------------------------------------------------------------------
void COM::AskPBTH()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x07;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetPBTH_lev(int pbth_n)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x07;
   IB_DecToBCD(TXstr[6],TXstr[7],pbth_n);
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::AskPBTL()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x08;
   TXstr[6]=IB_EoM;le=7;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetPBTL_lev(int pbtl_n)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x14;TXstr[5]=0x08;
   IB_DecToBCD(TXstr[6],TXstr[7],pbtl_n);
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}
//-----------------------------------------------------------------------------
void COM::AskCWSPEED()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;

   TXstr[4]=0x14;TXstr[5]=0x0C;
   TXstr[6]=IB_EoM;le=7;

   //TXstr[4]=0x1A;TXstr[5]=0x05;TXstr[6]=0x00;TXstr[7]=0x13;
   //TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetCWSPEED(int cwspeed_n)
{
 int x,le=0,cwspeed_l,cwspeed_h;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;

   TXstr[4]=0x1A;TXstr[5]=0x05;TXstr[6]=0x00;TXstr[7]=0x13;
   IB_DecToBCD(cwspeed_l,cwspeed_h,cwspeed_n);
   TXstr[8]=cwspeed_l;TXstr[9]=cwspeed_h;
   TXstr[10]=IB_EoM;le=11;

   //TXstr[4]=0x14;TXstr[5]=0x0C;TXstr[6]=cwspeed;//Alte ICOMs
   //TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}
//-----------------------------------------------------------------------------
void COM::AskTXPWR()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;

   TXstr[4]=0x14;TXstr[5]=0X0A;
   TXstr[6]=IB_EoM;le=7;

   //TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x01;
   //TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetTXPWR(int txpwr_n)
{
 int x,le=0,txpwr_l,txpwr_h;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x01;
   IB_DecToBCD(txpwr_l,txpwr_h,txpwr_n);
   TXstr[8]=txpwr_l;TXstr[9]=txpwr_h;
   TXstr[10]=IB_EoM;le=11;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios  
}

void COM::SetRX_TX(int rx_tx)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1C;TXstr[5]=0x00;
   if (rx_tx == 0) TXstr[6]=0x00;if (rx_tx == 1) TXstr[6]=0x01;
   TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}
//-----------------------------------------------------------------------------
void COM::AskRTTY_MF()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x10;
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetRTTY_MF(int mf)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x10;
   TXstr[8]=mf;
   TXstr[9]=IB_EoM;le=10;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios  
}

void COM::AskRTTY_SH()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x11;
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetRTTY_SH(int sh)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x11;
   TXstr[8]=sh;
   TXstr[9]=IB_EoM;le=10;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios  
}

void COM::AskRTTY_KP()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x12;
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetRTTY_KP(int kp)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x12;
   TXstr[8]=kp;
   TXstr[9]=IB_EoM;le=10;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios  
}

void COM::AskRTTY_RXDEC()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x01;TXstr[7]=0x07;
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetRTTY_RXDEC(int rxdec)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x01;TXstr[7]=0x07;
   TXstr[8]=rxdec;
   TXstr[9]=IB_EoM;le=10;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios  
}

void COM::AskRTTY_TPF()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x09;
   TXstr[8]=IB_EoM;le=9;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetRTTY_TPF(int tpf)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0X05;TXstr[6]=0x00;TXstr[7]=0x09;
   TXstr[8]=tpf;
   TXstr[9]=IB_EoM;le=10;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios  
}
//-----------------------------------------------------------------------------
void COM::SetTuStep(int stepind)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x10;TXstr[5]=stepind;
   TXstr[6]=IB_EoM;le=7;   
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios  
}
//-----------------------------------------------------------------------------
void COM::AskMEM(int bank,int memnum)
{
int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0x00;
   TXstr[6]=bank;
   IB_DecToBCD(TXstr[7],TXstr[8],memnum);
   TXstr[9]=IB_EoM;le=10+1;
  }
 for (x=0;x < le;x++) WriteChar(TXstr[x]);//All Radios 
}

void COM::SetMEM(int bank,int memnum,char *freqstr,int moind,int fiind,int dup,char *memtxt)
{
 int  x,y,strle,le=0;
 char fstr[13],memtxt_tmp[10];
 int  dest[5];

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x1A;TXstr[5]=0x00;
   //--------------------------
   TXstr[6]=bank;                                         //MEM-Bank
   IB_DecToBCD(TXstr[7],TXstr[8],memnum);                 //MEM-Nr.
   TXstr[9]=0;                                            //Split ???
   strcpy(fstr,freqstr);                                  //VFO A: F
   IB_FreqToSend(dest,fstr);
   for (x=10,y=0;y < 5;x++,y++) TXstr[x]=dest[y];
   switch (moind)                                         //VFO A: Mode
    {
     case  0:TXstr[15]=0x1;break;// USB
     case  1:TXstr[15]=0x0;break;// LSB
     case  2:TXstr[15]=0x5;break;// FM
     case  3:TXstr[15]=0x6;break;// FMW
     case  4:TXstr[15]=0x2;break;// AM
     case  5:TXstr[15]=0x3;break;// CW
     case  6:TXstr[15]=0x4;break;// RTTY
     case  7:TXstr[15]=0x7;break;// CW-R
     case  8:TXstr[15]=0x8;break;// RTTY-R
     default:TXstr[15]=0x1;break;
    }
   switch (fiind)                                         //VFO A: Filter
    {
     case  0:TXstr[16]=0x2;break;
     case  1:TXstr[16]=0x3;break;
     case  2:TXstr[16]=0x1;break;
     default:TXstr[16]=0x1;break;
    }
   if (moind == 3) TXstr[16]=0x1;//FMW muss immer mit fiind=2 laufen !!!  
   switch (dup)                                         //VFO A: DUP
    {
     case  0:TXstr[17]=0; break;
     case  1:TXstr[17]=16;break;
     case  2:TXstr[17]=32;break;
     default:TXstr[17]=0; break;
    } 
   TXstr[18]=0x00;//???
   TXstr[19]=0x08;//???
   TXstr[20]=133;//???
   TXstr[21]=0x00;//???
   TXstr[22]=0x08;//???
   TXstr[23]=133;//???
   TXstr[24]=0x00;//???
   TXstr[25]=0x00;//???
   TXstr[26]=35;//???
   for (x=27,y=10;x < 35;x++,y++) TXstr[x]=TXstr[y];      //VFO B: wie VFO A
   for (x=35,y=18;x < 44;x++,y++) TXstr[x]=TXstr[y];      //???
   for (x=44;x < 53;x++) TXstr[x]=0x61;
   strle=strlen(memtxt);                                  //TXT
   if (strle < 9) StrFiRi(memtxt,' ',9);
   for (x=44,y=0;x < 53;x++,y++) 
    {
     itoa((int)memtxt[y],memtxt_tmp,16);
     TXstr[x]=IB_HexStrToInt(memtxt_tmp);
    }                            
   //--------------------------
   TXstr[53]=IB_EoM;le=54+1;
   for (x=0;x < le;x++) WriteChar(TXstr[x]); 
  }
}

void COM::SetMEM_FromVFO()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x09;
   TXstr[5]=IB_EoM;le=6;   
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios   
}

void COM::SetMEM_Bank(int bank)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x08;TXstr[5]=0xA0;TXstr[6]=bank;
   TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios
}

void COM::SetMEM_ToNum(int memnum)
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x08;
   IB_DecToBCD(TXstr[5],TXstr[6],memnum);
   TXstr[7]=IB_EoM;le=8;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios
}

void COM::SetMEM_CLR()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x0B;
   TXstr[5]=IB_EoM;le=6;   
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios   
}
//-----------------------------------------------------------------------------
void COM::SendNOTOK()
{
 int x,le=0;

 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {  
   TXstr[0]=IB_SoM;TXstr[1]=IB_SoM;
   TXstr[2]=IRadio_IB_Adr_n;TXstr[3]=IB_PcAdr;
   TXstr[4]=0x5C;//******
   TXstr[5]=IB_EoM;le=6;
  }
 for (x=0;x < le+1;x++) WriteChar(TXstr[x]);//All Radios 
}
//*****************************************************************************
/* Siehe auch AskCOM_Idle + AskCOM_Spec (class RemDlg)

Rueckgabewerte allgemein
 -1   =KEINE chars in COM-RX-Buffer
 -2   =Schleife OHNE Ergebnis
 -3   =TIME OUT

Rueckgabewerte fr ICOM CI-V - Bus
 -100     =Wrong ICOM-Data  (i.e. wrong adress)        (10)
 -101     =Return cmd (transmitted to radio)           (11)
 
 IB_COLL  =Collision on ICOM-Bus                       (12) (-102)
 IB_OK    =ICOM-Data OK                                (13) (-103) 
 IB_NOTOK =ICOM-Data NOT OK                            (14) (-104)

 0x03     =Frequenz ausgelesen                         (17)   
 0x04     =Mode ausgelesen                             (18)
 0x14     =Diverses (s. Tabelle)
 0x15     =Diverses (s. Tabelle)                       (15)  
           z.B. SQL     ausgelesen                          
 0x16     =Diverses (s. Tabelle)                       (16)  
           z.B. S-Meter ausgelesen                          
 0x1A     =Diverses (s. Tabelle)        
*/

int COM::AskCOM_SPEC(int retexp)
{
 const int     wait=200,msgshowtime=1000;
 unsigned long EndT;
 int           res;
 
 COM_IsPolling=1;
 EndT=GetTickCount()+wait;
 res=-1;//ACHTUNG res -> while

 do
  {
   res=comport.ReadCOM();
   switch (res)
    {
     //ICOM CI-V - Bus---------------------------
     case     -100:res=-100;    break;//Wrong ICOM-Data (i.e. wrong adress) 
     case     -101:res=-101;    break;//Return cmd (transmitted to radio)  
     case IB_COLL :res=IB_COLL; break;
     case IB_OK   :res=IB_OK;   break;
     case IB_NOTOK:res=IB_NOTOK;break;
     case     0x03:res=0x03;    break;
     case     0x04:res=0x04;    break;
     case     0x14:res=0x14;    break;
     case     0x15:res=0x15;    break;
     case     0x16:res=0x16;    break;
     case     0x1A:res=0x1A;    break;
     //Other Radios------------------------------
     default:res=-3;break;
    }
   if (GetTickCount() > EndT) {res=-3;break;}//TIME OUT 
  }while (res != retexp);

 if (res == -3)//TIME OUT 
  {
   if (_TaMsgWin_ == 0) MyMsgWin((CFrameWnd*)this,IB_msg00,IB_msg04,msgshowtime,0,0,500,100);
  }

 COM_IsPolling=0;
 return res;
}

int COM::AskCOM_IDLE()
{
 int res,msgshowtime=300;

 COM_IsPolling=1;
 res=comport.ReadCOM();
 switch (res)
  {
   case   -1:res=-1;break;  // KEINE chars in COM-RX-Buffer
   case   -2:res=-2;break;  // Schleife OHNE Ergebnis
   case   -3:if (_TaMsgWin_ == 0) MyMsgWin((CFrameWnd*)this,IB_msg00,IB_msg04,msgshowtime,0,0,500,100);
             res=-3;break;  // TIME OUT
   //ICOM CI-V - Bus-----------------------------
   case     -100:res=-100;break;//Wrong ICOM-Data (i.e. wrong adress) 
   case     -101:res=-101;break;//Return cmd (transmitted to radio)

   case IB_COLL :if (_TaMsgWin_ == 0) MyMsgWin((CFrameWnd*)this,IB_msg00,IB_msg01,msgshowtime,0,0,200,150);
                 res=IB_COLL;break;//Collision on ICOM-Bus
   case IB_OK   :if (IRadio_IB_Conf)
                  { 
                   if (_TaMsgWin_ == 0) MyMsgWin((CFrameWnd*)this,IB_msg00,IB_msg02,msgshowtime,0,0,200,150);
   		           res=IB_OK;//ICOM-Data OK
                  }
                 break;
   case IB_NOTOK:if (IRadio_IB_Conf) 
                  {
                   if (_TaMsgWin_ == 0) MyMsgWin((CFrameWnd*)this,IB_msg00,IB_msg03,msgshowtime,0,0,200,150);
   		           res=IB_NOTOK;//ICOM-Data NOT OK
                  }
                 break;
   case     0x03:if (PtrToRemDisp != NULL) PtrToRemDisp->PostMessage(WM_REMDISP_FREQCHANGED);
                 res=0x03;break;
   case     0x04:RemDisp_UPD=1;
                 if (PtrToRemDisp != NULL) PtrToRemDisp->PostMessage(WM_REMDISP_STATUSCHANGED);   
                 res=0x04;break;
   case     0x14:res=0x14;break;
   case     0x15:RemDisp_UPD=1;
                 if (PtrToRemDisp != NULL) PtrToRemDisp->PostMessage(WM_REMDISP_STATUSCHANGED);  
                 res=0x15;break;
   case     0x16:if (SM_sel) SetSMstr(SMlev_n,1);else SetSMstr(SMlev_n,0);
                 RemDisp_UPD=1;
                 if (PtrToRemDisp != NULL) PtrToRemDisp->PostMessage(WM_REMDISP_STATUSCHANGED);
                 res=0x16;break;   
   case     0x1A:res=0x1A;break;
   //Other Radios--------------------------------
   default      :res=-3;break;
  }
 COM_IsPolling=0;
 return res;
}

int COM::ReadCOM()
{
 const int     wait=100;//wait=100
 unsigned long ActT,EndT;
 int           read;

 if (RXBufUsed() == 0) return -1;//-----------------------------Buffer leer
 //Anfang ICOM CI-V - Bus---------------------------------------
 if (Radio_Num < IRadios_IB_Max)
  {
   RXc=-1;RXb[0]=-1;EndT=GetTickCount()+wait;
   for (;;)
	{
     read=ReadChar();ActT=GetTickCount();
     if (read == 0xFC) {ClrRXBuf();return IB_COLL;}//-----------Collision on ICOM-Bus
     if (ActT > EndT) return -3;//------------------------------TIME OUT
     if (read != IB_SoM && RXc == -1) continue;
     if (read == IB_SoM)
      {
       if (RXc == -1) {RXc=0;RXb[0]=IB_SoM;EndT=GetTickCount()+wait;continue;}
       if (RXc ==  0) {RXc=1;RXb[1]=IB_SoM;continue;}
      }
     if (read > -1 ) {RXc++;RXb[RXc]=read;}
     if (read == IB_EoM || RXc == 99) break;//EoM || 99=Bufferende
	}
   //---------------------------
   if (RXb[0]==IB_SoM && RXb[1]==IB_SoM && RXb[2]==IRadio_IB_Adr_n && RXb[RXc]==IB_EoM)
    {
     return -101;//NBeep();
    }
   if (RXb[0]==IB_SoM && RXb[1]==IB_SoM && RXb[3]==IRadio_IB_Adr_n && RXb[RXc]==IB_EoM)
    {
     if (RXb[RXc-1]==0xFB) return IB_OK;//----------------------Data OK 
     if (RXb[RXc-1]==0xFA) return IB_NOTOK;//-------------------Data NOT OK
	 if (RXb[4] == 0x00 || RXb[4] == 0x03)//--------------------FREQUENZ 0x00/0x03
	  {
       RXBufferToFstr(9);
       return 0x03;
      }
	 if (RXb[4] == 0x01 || RXb[4] == 0x04)//--------------------MODE, FILTER 0x01/0x04
	  {
       RXBufferToMoFi(5,6);       
       return 0x04;
	  }
     if (RXb[4] == 0x14)//--------------------------------------0x14
      {
       if (RXb[5] == 0x01)                                           //AF-Level                               
        {
	     AFlev_n=IB_BCDtoDec(RXb[6],RXb[7]);return 0x14;
        }      
       if (RXb[5] == 0x02)                                           //RF-Level                               
        {
	     RFlev_n=IB_BCDtoDec(RXb[6],RXb[7]);return 0x14;
        }      
       if (RXb[5] == 0x03)                                           //SQL-Level                               
        {
	     SQLlev_n=IB_BCDtoDec(RXb[6],RXb[7]);return 0x14;
        }
       if (RXb[5] == 0x06)                                           //NR-Level                                     
        {
	     NRlev_n=IB_BCDtoDec(RXb[6],RXb[7]);
         return 0x14;
        }
       if (RXb[5] == 0x07)                                           //PBT-Innenregler                               
        {
	     PBTH_n=IB_BCDtoDec(RXb[6],RXb[7]);return 0x14;
        }
       if (RXb[5] == 0x08)                                           //PBT-Aussenregler                               
        {
	     PBTL_n=IB_BCDtoDec(RXb[6],RXb[7]);return 0x14;
        }
       if (RXb[5] == 0x0A)                                           //RF-Power                               
        {
	     TXPWR_n=IB_BCDtoDec(RXb[6],RXb[7]);return 0x14;
        }
       if (RXb[5] == 0x0C)                                           //KEY-Speed                               
        {
	     CWSPEED_n=IB_BCDtoDec(RXb[6],RXb[7]);return 0x14;
        }
       if (RXb[5] == 0x12)                                           //NB_lev                               
        {
	     NBlev_n=IB_BCDtoDec(RXb[6],RXb[7]);return 0x14;
        }       
      }		
     if (RXb[4] == 0x15)//--------------------------------------0x15		                  
      {
       if (RXb[5] == 0x01)                                           //SQL-Zustand                               
        {
	     if (RXb[6] == 0) SQL_oc=0;else SQL_oc=1;         
         return 0x15;
        }
       if (RXb[5] == 0x02)                                           //S-Meter
        {
         if (RXb[7] == IB_EoM)
          {
           SMlev_n=IB_BCDtoDec(0,RXb[6]);
           return 0x16;
          }
         if (RXb[7] != IB_EoM && RXb[8] == IB_EoM)
          {
           SMlev_n=IB_BCDtoDec(RXb[6],RXb[7]);
           return 0x16;
          }
        }
	  }
    if (RXb[4] == 0x1A && RXb[5] == 0x00)//---------------------0x1A,0x00
      {
       RXBufferToFstr(14);// Fact_s   Fact_n

       return 0x1A;
      }
    if (RXb[4] == 0x1A && RXb[5] == 0x05)//---------------------0x1A,0x05
      {
       if (RXb[6]==0x00)//--------------------------------------0x1A,0x05,0x00
        {
         if (RXb[7]==0x01)                                           //TXPWR
          {
           TXPWR_n=IB_BCDtoDec(RXb[8],RXb[9]);return 0x1A;
          }
         if (RXb[7]==0x09)                                           //RTTY_TPF
          {
           RTTY_TPFsw_n=RXb[8];return 0x1A;
          }
         if (RXb[7]==0x10)                                           //RTTY_MF
          {
           RTTY_MFsw_n=RXb[8];return 0x1A;
          }
         if (RXb[7]==0x11)                                           //RTTY_SH
          {
           RTTY_SHsw_n=RXb[8];return 0x1A;
          }
         if (RXb[7]==0x12)                                           //RTTY_KP
          {
           RTTY_KPsw_n=RXb[8];return 0x1A;
          }
         if (RXb[7]==0x13)                                           //CWSPEED
          {
           CWSPEED_n=IB_BCDtoDec(RXb[8],RXb[9]);return 0x1A;
          }
        }
       if (RXb[6]==0x01)//--------------------------------------0x1A,0x05,0x01
        {
         if (RXb[7]==0x07)                                           //RTTY_RXDEC
          {
           RTTY_RXDECsw_n=RXb[8];return 0x1A;
          }
         if (RXb[7]==0x13)                                           //NB-Width
          {
           NBwid_n=IB_BCDtoDec(RXb[8],RXb[9]);return 0x1A;
          }
         if (RXb[7]==0x14)                                           //NR-Level
          {
           NRlev_n=IB_BCDtoDec(0,RXb[8]);
           NRlev_n=(NRlev_n*255)/15;
           return 0x1A;
          }
        }
	  }
    }else return -100;//Ung. ICOM-Daten: z.B. falsche Adresse
  }
 //Ende ICOM CI-V - Bus / Other Radios--------------------------
 return -2;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
//*DEBUG*****************************
 for (x=0;x<30;x++) RXb[x]=0;
//*ENDE DEBUG************************

//*DEBUG*****************************
char anz[200];
wsprintf(anz,"00  %d\n01  %d\n02  %d\n03 %d\n04 %d\n05 %d\n06 %d\n07 %d\n"
             "08  %d\n09  %d\n10  %d\n",
         RXb[0],RXb[1],RXb[2],RXb[3],RXb[4],RXb[5],RXb[6],RXb[7],
         RXb[8],RXb[9],RXb[10]);
::MessageBox(GetFocus(),anz,"DEBUG",MB_OK);
//*ENDE DEBUG************************
*/
